<script>
import Layout from "../../layouts/main";
import PageHeader from "../../components/page-header";
import config from "../../config";
import pagination from "laravel-vue-pagination";
import { pageService } from "../../services";
import { success_message, error_message } from "../../Helper/helper";

/**
 * Starter component
 */
export default {
  components: { Layout, PageHeader, pagination, pageService },
  data() {
    return {
      sortBy: "id",
      sortDesc: true,
      pages: [],
      paginations: {},
      limit: 1,
      search: "",
      config: config,
      loading: true,
      fields: [
        {
          key: "page_name",
          label: this.trans.get("__JSON__.Page Name"),
          sortable: true,
        },
        {
          key: "display_in",
          label: this.trans.get("__JSON__.Display In"),
          sortable: false,
        },
        {
          key: "identifier",
          label: this.trans.get("__JSON__.Category"),
          sortable: false,
        },
        {
          key: "action",
          label: this.trans.get("__JSON__.Action"),
          sortable: false,
        },
      ],
    };
  },
  mounted() {
    this.getContentPage();
  },
  methods: {
    getContentPage(page) {
      this.loading = true;
      pageService.getContentPage({
        search: this.search,
        sortBy: this.sortBy,
        orderBy: this.sortDesc ? "asc" : "desc",
        page: page && page > 0 ? page : 1,
      }).then((response) => {
        this.loading = false;
        this.paginations = response.data.result;
        this.pages = response.data.result.data;
      });
    },
    sortingChanged(ctx) {
      if(ctx.sortBy){
        this.sortBy = ctx.sortBy;
        this.sortDesc = ctx.sortDesc;
        this.getContentPage();
      }
    },

    deleteById(id) {
      if (confirm(this.trans.get("__JSON__.Are you sure you want to delete?"))) {
        pageService.deleteContentPage({ id: id }).then((response) => {
          if (response.data.code === 200) {
            success_message(response.data.message);
            this.getContentPage();
          } else {
            error_message(response.data.message);
          }
        });
      }
    }
  }
};
</script>

<template>
  <Layout>
    <div>
      <div class="row header-new">
        <div class="col-12">
          <div class="d-flex align-items-center justify-content-between icon-main-page">
            <div class="page-title-left">
              <div class="avatar-xs mr-3">
                <span class="avatar-title rounded-circle bg-soft-primary text-primary font-size-18">
                  <i class="bx bx-briefcase"></i>
                </span>
              </div>
              <h4 class="mb-0 font-size-18">{{ trans.trans('__JSON__.Content Pages') }}</h4>
            </div>
            <div class="page-title-right">
              <router-link v-if="$auth.hasPermission(config.permissions.content_pages_write)" :to="{ name: 'content-page-add' }" class="btn btn-success btn-rounded add-btn avatar-xs d-flex align-items-center justify-content-center">
                <i class="mdi mdi-plus mdi-18px" v-b-tooltip.hover.v-light :title="trans.get('__JSON__.Add Content Page')"></i>
              </router-link>
              <router-link v-if="$auth.hasPermission(config.permissions.content_pages_write)" :to="{ name: 'content-page-add' }" class="btn btn-success btn-rounded mr-2 m-add-btn">
                <i class="mdi mdi-plus"></i>
              </router-link>
            </div>
          </div>
        </div>
      </div>
      <!-- end row -->
      <div class="row">
        <div class="col-12 list-table-main">
          <div class="card">
            <div class="card-body">
              <!-- <div class="row"> -->
              <div class="table-main-list cuisine-table table-responsive content-page table-border-0 scroll-tab">
                <b-table :items="pages" :fields="fields" :sort-by.sync="sortBy" :no-local-sorting="true" @sort-changed="sortingChanged" :busy="loading" show-empty>
                  <template #table-busy>
                    <div class="text-center text-danger my-2">
                      <b-spinner class="align-middle"></b-spinner>
                      <strong>{{ trans.get('__JSON__.Loading...') }}</strong>
                    </div>
                  </template>

                  <template v-slot:cell(page_name)="data">
                    <h5 class="font-size-14 mb-1">
                      <div>{{ data.item.page_name }}</div>
                    </h5>
                  </template>

                  <template v-slot:cell(display_in)="data">
                    <h5 class="font-size-14 mb-1">
                      <div>
                        {{JSON.parse(data.item.display_in).customer == '1' ? 'Customer' : '' }}
                        {{JSON.parse(data.item.display_in).partner == '1' ? (JSON.parse(data.item.display_in).customer == '1' ? ' , ' : '') + 'Partner' : ''}}
                        {{((JSON.parse(data.item.display_in).customer == '1' || JSON.parse(data.item.display_in).partner =='1') && JSON.parse(data.item.display_in).driver == '1') ? ', Driver' : (JSON.parse(data.item.display_in).driver == '1') ? 'Driver' : ''}}
                        {{(JSON.parse(data.item.display_in).customer == '0' && JSON.parse(data.item.display_in).partner == '0' && JSON.parse(data.item.display_in).driver == '0') ? '-' : ''}}
                      </div>
                    </h5>
                  </template>

                  <template v-slot:cell(identifier)="data">
                    <h5 class="font-size-14 mb-1">
                      <div v-if="data.item.identifier == '1'">{{ trans.get('__JSON__.Terms & Condition') }}</div>
                      <div v-else-if="data.item.identifier == '2'">{{ trans.get('__JSON__.Privacy Policy') }}</div>
                      <div v-else-if="data.item.identifier == '3'">{{ trans.get('__JSON__.Other') }}</div>
                      <div v-else>-</div>
                    </h5>
                  </template>

                  <template v-slot:cell(action)="data">
                    <div class="vendor-btn">
                      <router-link v-if="$auth.hasPermission(config.permissions.content_pages_write)"
                        :to="{ name: 'content-page-edit', params: { id: base64(data.item.id) } }"
                        class="btn btn-success btn-sm btn-rounded ml-1">{{ trans.get('__JSON__.Edit') }}</router-link>
                      <!-- <a :href="config.appurl+'page/'+base64(data.item.id)+'/'+data.item.vendor_id+'/'+data.item.page_title.toLowerCase().replaceAll(' ','-')" class="btn btn-primary btn-sm btn-rounded" target="_blank"> {{ trans.get('__JSON__.View') }} </a> -->
                      <div v-if="data.item.page_content != ''">                        
                        <a :href="config.appurl + 'page/' + base64(data.item.id + ',' + data.item.client_id)"
                          class="btn btn-primary btn-sm btn-rounded" target="_blank"> {{ trans.get('__JSON__.View') }}
                        </a>
                      </div>
                      <div v-else>
                        <a :href="data.item.content_link" class="btn btn-primary btn-sm btn-rounded" target="_blank"> {{
                          trans.get('__JSON__.View') }} </a>
                      </div>
                      <button v-if="$auth.hasPermission(config.permissions.content_pages_write)" type="submit"
                        class="btn btn-danger btn-sm btn-rounded ml-1" @click="deleteById(base64(data.item.id))">{{
                          trans.get('__JSON__.Delete') }}</button>
                    </div>
                  </template>

                  <template #empty>
                    <p class="text-center">{{ trans.get('__JSON__.No Pages') }}</p>
                  </template>

                </b-table>
              </div>
              <div class="row col-sm-5 offset-sm-7">
                <div class="col">
                  <div class="dataTables_paginate paging_simple_numbers float-right">
                    <ul class="pagination pagination-rounded mb-0">
                      <!-- pagination -->
                      <pagination :data="paginations" :limit="limit" @pagination-change-page="getContentPage">
                      </pagination>
                    </ul>
                  </div>
                </div>
              </div>
              <!-- </div> -->
            </div>
          </div>
        </div>
      </div>
      <!-- end row -->
    </div>

  </Layout>
</template>

<style>
.content-page .table thead th:nth-child(2) {
  pointer-events: none;
}
</style>